=== scripts/Makefile ===
# Makefile for lmbench scripts subdir.
#$Id$

get:
	get -s 

clean:
