## lmbench 3.0-a9%2Bdebian.1

=== debian/changelog ===
lmbench (3.0-a9+debian.1-6build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:55:51 +1100

lmbench (3.0-a9+debian.1-6build2) noble; urgency=medium

  * No-change rebuild against libtirpc3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 00:11:03 +0000

lmbench (3.0-a9+debian.1-6build1) noble; urgency=medium

  * No-change rebuild against libtirpc3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 09:27:07 +0000

lmbench (3.0-a9+debian.1-6) unstable; urgency=medium

  * QA upload.

  [ Matthias Klose ]
  * Fix build with glibc 2.33.

  [ Andreas Beckmann ]
  * Fix broken man page symlinks. Closes: #903794.

 -- Matthias Klose <doko@debian.org>  Thu, 27 May 2021 12:06:42 +0200

lmbench (3.0-a9+debian.1-5) unstable; urgency=medium

  * Properly orphan the package

 -- Al Stone <ahs3@debian.org>  Sun, 21 Mar 2021 14:14:41 -0600

lmbench (3.0-a9+debian.1-4) unstable; urgency=medium

  * Remove use of dpatch, move to default quilt usage 
  * Fix up config path (Closes: #786941)
  * Use size_t not int to avoid overflow (Closes: #902609)
  * Add in Vcs-Git field to debian/control
  * Fix usage of ${perl:Depends}
  * Update Standards-Version
  * Fix lintian warnings about perl shebang, debhelper levels, native
    language encoding, lack of debug symbols, and extra white space

 -- Al Stone <ahs3@debian.org>  Sun, 14 Mar 2021 15:07:59 -0600

lmbench (3.0-a9+debian.1-3) unstable; urgency=medium

  * SCCS files are no longer usable for building the package

 -- Al Stone <ahs3@debian.org>  Wed, 23 Oct 2019 21:46:19 -0600

lmbench (3.0-a9+debian.1-2) unstable; urgency=medium

  * Only ship README file in the main package.  (Closes: #875786)

 -- dann frazier <dannf@debian.org>  Mon, 18 Sep 2017 08:57:57 -0600

lmbench (3.0-a9+debian.1-1) unstable; urgency=medium

  * Acknowledge NMUs, thanks Andreas!
  * Use upstream tarball as orig.tar.gz. This appends a +debian.1 to the
    upstream version to avoid conflicting with the previous orig.tar.gz.
    The previous orig.tar.gz was a tarball that contained the upstream
    tarball, which had to be unpacked prior to build in debian/rules.
  * Switch to dpkg-source 3.0 (quilt) format from dpatch, which is
    deprecated.  (Closes: #875644)
  * Add myself to Uploaders.
  * debian/rules: Remove unused H_ARCH/OPTIMIZATION variables.
  * debian/info: Remove. The listed file does not exist in the source.
  * Turn debhelper compat level up to 11.
  * Allow lmbench-docs to install most documentation in the main package,
    as recommended by §12.3 since 3.9.7.
  * Do not generate lmbench-run manpage if DEB_BUILD_OPTIONS contains
    'nodocs'.
  * Add a "lmbench-" prefix to manpages that conflict with other packages.
    Since this allows us to include all of the manpages in lmbench, stop
    including separate copies in lmbench-doc.
  * d/p/dynamic-tcp-backlog.patch: Dynamically increase the TCP backlog on
    high core-count systems. (LP: #1706735)
  * Bump Standards-Version to 4.1.0.

 -- dann frazier <dannf@debian.org>  Wed, 13 Sep 2017 16:39:57 -0600

lmbench (3.0-a9-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Add XS-Autobuild: yes after getting the package whitelisted for
    autobuilding.  (Closes: #717243)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 09 Oct 2016 20:59:51 +0200

lmbench (3.0-a9-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add build-arch/build-indep targets.  (Closes: #822051)
  * Switch to debhelper compat level 5.  (Closes: #817567)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 18 Sep 2016 02:12:05 +0200

lmbench (3.0-a9-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Do not ship /var/{run,tmp}/lmbench.  (Closes: #689897)
  * Add Homepage: http://www.bitmover.com/lmbench/
  * Fix typos.  (Closes: #626676, #697536, #707013)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 28 Jan 2015 19:08:15 +0100

lmbench (3.0-a9-1) unstable; urgency=low

  * Update to latest upstream (3.0-a9).
  * Update to latest Standards-Version.
  * Incorporate Ubuntu patch: depend on libc6-dev (LP: #246618)
  * Closes: bug#470279 -- replaced all uses of /usr/tmp with /var/tmp
  * Closes: bug#496427 -- removed risk of /tmp symlink attacks by moving
    all usage of /tmp to /var/tmp/lmbench

 -- Al Stone <ahs3@debian.org>  Sun, 22 Feb 2009 18:20:00 -0700

lmbench (3.0-a7-1) unstable; urgency=low

  * Update to latest upstream.
  * Update to latest Standards-Version.

 -- Al Stone <ahs3@debian.org>  Sat, 21 Oct 2006 18:29:00 -0600

lmbench (3.0-a5-3) unstable; urgency=low

  * Closes: bug#358785 -- missing manpage causes dangling symlinks
  * bw_tcp.8 had wrong .TH man header value

 -- Al Stone <ahs3@debian.org>  Sun,  2 Apr 2006 16:48:02 -0600

lmbench (3.0-a5-2) unstable; urgency=low

  * Closes: bug#299064 -- remove use of swear word as name of a script

 -- Al Stone <ahs3@debian.org>  Wed, 22 Mar 2006 15:57:17 -0700

lmbench (3.0-a5-1) unstable; urgency=low

  * Update to latest source (http://sourceforge.net.projects/lmbench).
  * Toss out the old build method (dependent on BitKeeper) and replace
    with patches to upstream tarball.
  * Update Debian standards version.
  * Closes: bug#296594: lmbench-run fails upon saving configuration
  * Closes: bug#302662: 'man lmbench' typos: "fundemental"

 -- Al Stone <ahs3@debian.org>  Tue, 21 Mar 2006 23:22:01 -0700

lmbench (2.0-patch2-9) unstable; urgency=low

  * Update to latest source.
  * Closes: bug#267207 -- sparc binaries are 64-bit; needed to build
    and upload on sparc, sparc64
  * Closes: bug#270782 -- clock(8) man page still conflicting; needed
    to build and upload for PowerPC
  * Closes: bug#271251 -- recent version not available for PowerPC;
    needed to build and upload for PowerPC
  * Closes: bug#273446 -- typo in Makefile and PPC build failed; fixed,
    rebuilt and uploaded


