## lmbench 3.0-a9+debian.1

=== debian/changelog ===
lmbench (3.0-a9+debian.1-10) unstable; urgency=medium

  * QA upload.
  * Build with -std=gnu17 to fix FTBFS with GCC 15.  (Closes: #1114188)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 11 Sep 2025 02:17:43 +0200

lmbench (3.0-a9+debian.1-9) unstable; urgency=medium

  * QA upload.
  * Fix Homepage URL. (Closes: #1098640)

 -- Kiran S Kunjumon <kiran@disroot.org>  Sun, 04 May 2025 06:48:18 +0000

lmbench (3.0-a9+debian.1-8) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with GCC 14.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 Aug 2024 16:05:46 +0200

lmbench (3.0-a9+debian.1-7) unstable; urgency=medium

  * QA upload.
  * Reimport into GIT.
  * Add Build-Depends: libtirpc-dev.
  * Switch to debhelper-compat (= 13).
  * Set Rules-Reuires-Root: no.
  * Enable all hardening flags.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 25 Mar 2024 19:12:15 +0100
