=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CONFLICTING_MANPAGES := graph.1 rccs.1 bargraph.1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/tirpc -DHAVE_socklen_t
export DEB_CFLAGS_MAINT_APPEND	 = -std=gnu17

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	docbook-to-man debian/lmbench-run.sgml >debian/lmbench-run.1
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/lmbench-run.1
	rm -rf debian/doc debian/manpages debian/scripts

override_dh_auto_install:
	rm -rf debian/scripts && cp -a scripts debian
	mv debian/scripts/SHIT debian/scripts/STUFF
	chmod -x debian/scripts/Makefile debian/scripts/README \
		debian/scripts/TODO debian/scripts/info-template

	rm -rf debian/doc && cp -a doc debian
	rm -rf debian/manpages && mkdir debian/manpages
	mv debian/doc/*.[1-9] debian/manpages
	for manpage in $(CONFLICTING_MANPAGES); do \
		mv debian/manpages/$$manpage \
			debian/manpages/lmbench-$$manpage; \
	done

	dh_auto_install
